#include "CVI_SPI.h"

typedef interface tagMCLRS232USBToSPI__USB_To_SPI_Interface MCLRS232USBToSPI__USB_To_SPI_Interface;

typedef struct tagMCLRS232USBToSPI__USB_To_SPI_VTable
{
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This, 
	                                                         REFIID riid, 
	                                                         void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This, 
	                                                           UINT __RPC_FAR *pctinfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This, 
	                                                      UINT iTInfo, 
	                                                      LCID lcid, 
	                                                      ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This, 
	                                                        REFIID riid, 
	                                                        LPOLESTR __RPC_FAR *rgszNames, 
	                                                        UINT cNames, 
	                                                        LCID lcid, 
	                                                        DISPID __RPC_FAR *rgDispId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Invoke )( MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR * This, 
	                                                 DISPID dispIdMember, 
	                                                 REFIID riid, 
	                                                 LCID lcid, 
	                                                 WORD wFlags, 
	                                                 DISPPARAMS __RPC_FAR *pDispParams, 
	                                                 VARIANT __RPC_FAR *pVarResult, 
	                                                 EXCEPINFO __RPC_FAR *pExcepInfo, 
	                                                 UINT __RPC_FAR *puArgErr);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Available_SN_List_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                                BSTR *SN_List, 
	                                                                short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetStatus_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                    short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_ModelName_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                         BSTR *modelName, 
	                                                         short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_SN_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                  BSTR *SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Send_SPI_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                   BSTR *str_to_send, 
	                                                   short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_PulsWidth_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                        short *pulsWidth, 
	                                                        short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_SPI_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                   short *noOfBit, 
	                                                   short *waitForReady, 
	                                                   BSTR *str_Ret, 
	                                                   short *arg4);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Connect_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This, 
	                                                  BSTR SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Disconnect_) (MCLRS232USBToSPI__USB_To_SPI_Interface __RPC_FAR *This);

} MCLRS232USBToSPI__USB_To_SPI_VTable;

typedef interface tagMCLRS232USBToSPI__USB_To_SPI_Interface
{
	CONST_VTBL MCLRS232USBToSPI__USB_To_SPI_VTable __RPC_FAR *lpVtbl;
} MCLRS232USBToSPI__USB_To_SPI_Interface;

const IID MCLRS232USBToSPI_IID__USB_To_SPI =
	{
		0x26CC0D7F, 0xE43E, 0x4351, 0x86, 0xF4, 0x78, 0xD7, 0x5C, 0x54, 0x47, 0x8B
	};

HRESULT CVIFUNC MCLRS232USBToSPI_New_USB_To_SPI (const char *server,
                                                 int supportMultithreading,
                                                 LCID locale, int reserved,
                                                 CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x79D52239, 0x6AF2, 0x4F82, 0xA1, 0xC7, 0xDC, 0x89, 0xFE,
	              0x41, 0xFA, 0x2A};

	__result = CA_CreateObjectByClassIdEx (&clsid, server,
	                                       &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                       supportMultithreading, locale,
	                                       reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI_Open_USB_To_SPI (const char *fileName,
                                                  const char *server,
                                                  int supportMultithreading,
                                                  LCID locale, int reserved,
                                                  CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x79D52239, 0x6AF2, 0x4F82, 0xA1, 0xC7, 0xDC, 0x89, 0xFE,
	              0x41, 0xFA, 0x2A};

	__result = CA_LoadObjectFromFileByClassIdEx (fileName, &clsid, server,
	                                             &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                             supportMultithreading, locale,
	                                             reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI_Active_USB_To_SPI (const char *server,
                                                    int supportMultithreading,
                                                    LCID locale, int reserved,
                                                    CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x79D52239, 0x6AF2, 0x4F82, 0xA1, 0xC7, 0xDC, 0x89, 0xFE,
	              0x41, 0xFA, 0x2A};

	__result = CA_GetActiveObjectByClassIdEx (&clsid, server,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          supportMultithreading, locale,
	                                          reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIGet_Available_SN_List (CAObjHandle objectHandle,
                                                                   ERRORINFO *errorInfo,
                                                                   char **SN_List,
                                                                   short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN_List__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN_List, &SN_List__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Available_SN_List_ (__vtblIFacePtr,
	                                                            &SN_List__AutoType,
	                                                            &arg2__Temp));

	if (SN_List)
		{
		CA_FreeMemory (*SN_List);
		*SN_List = 0;
		}
	if (SN_List)
		__caErrChk (CA_BSTRGetCString (SN_List__AutoType, SN_List));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN_List__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN_List)
			{
			CA_FreeMemory (*SN_List);
			*SN_List = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIGetStatus (CAObjHandle objectHandle,
                                                       ERRORINFO *errorInfo,
                                                       short *arg1)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetStatus_ (__vtblIFacePtr,
	                                                &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIRead_ModelName (CAObjHandle objectHandle,
                                                            ERRORINFO *errorInfo,
                                                            char **modelName,
                                                            short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR modelName__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*modelName, &modelName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_ModelName_ (__vtblIFacePtr,
	                                                     &modelName__AutoType,
	                                                     &arg2__Temp));

	if (modelName)
		{
		CA_FreeMemory (*modelName);
		*modelName = 0;
		}
	if (modelName)
		__caErrChk (CA_BSTRGetCString (modelName__AutoType, modelName));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (modelName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (modelName)
			{
			CA_FreeMemory (*modelName);
			*modelName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIRead_SN (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     char **SN, short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_SN_ (__vtblIFacePtr,
	                                              &SN__AutoType, &arg2__Temp));

	if (SN)
		{
		CA_FreeMemory (*SN);
		*SN = 0;
		}
	if (SN)
		__caErrChk (CA_BSTRGetCString (SN__AutoType, SN));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN)
			{
			CA_FreeMemory (*SN);
			*SN = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPISend_SPI (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      char **str_to_send,
                                                      short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR str_to_send__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*str_to_send, &str_to_send__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Send_SPI_ (__vtblIFacePtr,
	                                               &str_to_send__AutoType,
	                                               &arg2__Temp));

	if (str_to_send)
		{
		CA_FreeMemory (*str_to_send);
		*str_to_send = 0;
		}
	if (str_to_send)
		__caErrChk (CA_BSTRGetCString (str_to_send__AutoType, str_to_send));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (str_to_send__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (str_to_send)
			{
			CA_FreeMemory (*str_to_send);
			*str_to_send = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPISet_PulsWidth (CAObjHandle objectHandle,
                                                           ERRORINFO *errorInfo,
                                                           short *pulsWidth,
                                                           short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_PulsWidth_ (__vtblIFacePtr,
	                                                    pulsWidth, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIRead_SPI (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *noOfBit,
                                                      short *waitForReady,
                                                      char **str_Ret,
                                                      short *arg4)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR str_Ret__AutoType = 0;
	short arg4__Temp;

	__caErrChk (CA_CStringToBSTR (*str_Ret, &str_Ret__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_SPI_ (__vtblIFacePtr, noOfBit,
	                                               waitForReady,
	                                               &str_Ret__AutoType,
	                                               &arg4__Temp));

	if (str_Ret)
		{
		CA_FreeMemory (*str_Ret);
		*str_Ret = 0;
		}
	if (str_Ret)
		__caErrChk (CA_BSTRGetCString (str_Ret__AutoType, str_Ret));
	if (arg4)
		{
		*arg4 = arg4__Temp;
		}

Error:
	CA_FreeBSTR (str_Ret__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (str_Ret)
			{
			CA_FreeMemory (*str_Ret);
			*str_Ret = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIConnect (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     const char *SN, short *arg2)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Connect_ (__vtblIFacePtr, SN__AutoType,
	                                              &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLRS232USBToSPI__USB_To_SPIDisconnect (CAObjHandle objectHandle,
                                                        ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	MCLRS232USBToSPI__USB_To_SPI_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLRS232USBToSPI_IID__USB_To_SPI,
	                                          0, &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Disconnect_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLRS232USBToSPI_IID__USB_To_SPI,
	                    __result, errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}
